#define DJ_DBG
#include <djVec.h>

using namespace dj;

int main(int, char **)
{
  DJ_DBG_LOG();
  DJ_DBG_FNC("vec");
  
  Vec2i a, b(1, 2);
  DJ_DBG_PRN("a = " << a);
  DJ_DBG_PRN("b = " << b);
  a = b;
  DJ_DBG_PRN("a = " << a);
  a = Vec2i(3, 4);
  DJ_DBG_PRN("a = " << a);
  a[0] = 5;
  a[1] = 6;
  DJ_DBG_PRN("a = " << a);
  DJ_DBG_PRN("a = " << a.x() << " " << a.y());
  DJ_DBG_PRN("");

  DJ_DBG_PRN("a = " << a);
  DJ_DBG_PRN("b = " << b);
  DJ_DBG_PRN("a + b = " << (a + b));
  DJ_DBG_PRN("a - b = " << (a - b));
  DJ_DBG_PRN("a * b = " << (a * b));
  DJ_DBG_PRN("a / b = " << (a / b));
  DJ_DBG_PRN("-a = " << -a);
  DJ_DBG_PRN("");
  
  DJ_DBG_PRN("a = " << a);
  DJ_DBG_PRN("b = " << b);
  DJ_DBG_PRN("swap(a) = " << swap(a));
  DJ_DBG_PRN("min(a, b) = " << min(a, b));
  DJ_DBG_PRN("max(a, b) = " << max(a, b));
  DJ_DBG_PRN("a == b = " << (a == b));
  DJ_DBG_PRN("a != b = " << (a != b));
  DJ_DBG_PRN("a < b = " << (a < b));
  DJ_DBG_PRN("a <= b = " << (a <= b));
  DJ_DBG_PRN("a > b = " << (a > b));
  DJ_DBG_PRN("a >= b = " << (a >= b));
}
